import type { HDOMImplementation, HDOMOpts } from "./api.js";
/**
 * One-off hdom tree conversion & target DOM application. Takes same
 * options as {@link start}, but performs no diffing and only creates or
 * hydrates target once. The given tree is first normalized and if
 * result is `null` or `undefined` no further action will be taken.
 *
 * @param tree - component tree
 * @param opts - hdom config options
 * @param impl - hdom implementation
 */
export declare const renderOnce: (tree: any, opts?: Partial<HDOMOpts>, impl?: HDOMImplementation<any>) => void;
//# sourceMappingURL=render-once.d.ts.map