import { derefContext } from "@thi.ng/hiccup/deref";
import { DEFAULT_IMPL } from "./default.js";
import { resolveRoot } from "./resolve.js";
const start = (tree, opts = {}, impl = DEFAULT_IMPL) => {
  const _opts = { root: "app", ...opts };
  let prev = [];
  let isActive = true;
  const root = resolveRoot(_opts.root, impl);
  const update = () => {
    if (isActive) {
      _opts.ctx = derefContext(opts.ctx, _opts.autoDerefKeys);
      const curr = impl.normalizeTree(_opts, tree);
      if (curr != null) {
        if (_opts.hydrate) {
          impl.hydrateTree(_opts, root, curr);
          _opts.hydrate = false;
        } else {
          impl.diffTree(_opts, root, prev, curr);
        }
        prev = curr;
      }
      isActive && requestAnimationFrame(update);
    }
  };
  requestAnimationFrame(update);
  return () => isActive = false;
};
export {
  start
};
